SystemOrganization addCategory: #'Practica2-Ejercicio1'!
SystemOrganization addCategory: #'Practica2-Ejercicio2'!

Object subclass: #Empleado
	instanceVariableNames: 'nombre direccion estadoCivil fechaNacimiento sueldoBasico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!Empleado methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/13/2012 00:31'!
calcularEdad
	"Mtodo que devuelve la edad de la persona en aos"

	| edad |
	edad := 0.
	edad := ((Date today - fechaNacimiento) days / 365.25) asInteger.
	^ edad! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 01:13'!
calcularSueldoBruto
	^ self calcularSueldoBruto: nil! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 18:38'!
calcularSueldoBruto: aRecibo
	self subclassResponsibility! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 01:12'!
calcularSueldoNeto
	^ self calcularSueldoNeto: nil! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 01:28'!
calcularSueldoNeto: aRecibo
	| sueldoBruto totalRetenciones |
	sueldoBruto := self calcularSueldoBruto: aRecibo.
	totalRetenciones := self calcularTotalRetenciones: aRecibo.
	aRecibo isNil ifFalse: [ aRecibo sueldoBruto: sueldoBruto].
	^ sueldoBruto - totalRetenciones! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 01:15'!
calcularTotalRetenciones
	^ self calcularTotalRetenciones: nil! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 18:38'!
calcularTotalRetenciones: aRecibo
	self subclassResponsibility! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:08'!
direccion
	^ direccion! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:54'!
direccion: aDireccion
	direccion := aDireccion! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:08'!
estadoCivil
	^ estadoCivil! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
estadoCivil: aEstadoCivil
	estadoCivil := aEstadoCivil! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:09'!
fechaNacimiento
	^ fechaNacimiento! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
fechaNacimiento: aFechaNacimiento
	fechaNacimiento := aFechaNacimiento! !

!Empleado methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:51'!
generarRecibo
	"Mtodo que genera el recibo de haberes por cada empleado"

	| recibo |
	recibo := ReciboHaberes new.
	recibo nombre: nombre.
	recibo direccion: direccion.
	recibo fechaEmision: Date today.
	recibo sueldoNeto: (self calcularSueldoNeto: recibo).
	^ recibo! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:07'!
nombre
	^ nombre! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
nombre: aNombre
	nombre := aNombre! !

!Empleado methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:09'!
sueldoBasico
	^ sueldoBasico! !

!Empleado methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 23:55'!
sueldoBasico: aSueldoBasico
	sueldoBasico := aSueldoBasico! !

Empleado subclass: #EmpleadoPermanente
	instanceVariableNames: 'cantidadHijos antiguedad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:21'!
antiguedad
"Mtodo que retorna la antigedad del empleado de planta permanente en la empresa"
	^ antiguedad! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:21'!
antiguedad: anAntiguedad 
"Mtodo que asigna la cantidad en aos que representa la antigedad del empleado de planta permanente en la empresa"
	antiguedad := anAntiguedad ! !

!EmpleadoPermanente methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 19:46'!
calcularSueldoBruto: aRecibo
	"Mtodo para calcular el sueldo bruto de cada empleado de planta permanente"

	| sueldoBruto salarioFamiliar asignacionHijo asignacionConyuge asignacionAntiguedad |
	asignacionHijo := 150 * cantidadHijos.
	(estadoCivil = 'Casado' | estadoCivil) = 'Casada'
		ifFalse: [ asignacionConyuge := 0 ]
		ifTrue: [ asignacionConyuge := 100 ].
	asignacionAntiguedad := 50 * antiguedad.
	salarioFamiliar := asignacionHijo + asignacionConyuge + asignacionAntiguedad.
	sueldoBruto := sueldoBasico + salarioFamiliar.
	aRecibo isNil
		ifFalse: [ 
			aRecibo
				addConcepto: 'Sueldo bsico' monto: sueldoBasico nivel: 0;
				addConcepto: 'Salario familiar' monto: salarioFamiliar nivel: 0;
				addConcepto: 'Asigancin por Hijos' monto: asignacionHijo nivel: 1;
				addConcepto: 'Asigancin por cnyugue' monto: asignacionConyuge nivel: 1;
				addConcepto: 'Asignacin por antigedad' monto: asignacionAntiguedad nivel: 1 ].
	^ sueldoBruto! !

!EmpleadoPermanente methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 19:48'!
calcularTotalRetenciones: aRecibo
	"Este mtodo calcula el total de retenciones que tiene un empleado de planta permanente"

	| totalRetenciones obraSocial aportesjubilatorios sueldoBruto |
	sueldoBruto := self calcularSueldoBruto.
	obraSocial := 0.1 * sueldoBruto + (20 * cantidadHijos).
	aportesjubilatorios := 0.15 * sueldoBruto.
	totalRetenciones := obraSocial + aportesjubilatorios.
	aRecibo isNil
		ifFalse: [ 
			aRecibo
				addConcepto: 'Total retenciones' monto: totalRetenciones negated nivel: 0;
				addConcepto: 'Obra social' monto: obraSocial negated nivel: 1;
				addConcepto: 'Aportes jubilatorios' monto: aportesjubilatorios negated nivel: 1 ].
	^ totalRetenciones! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:24'!
cantidadHijos
"Mtodo que retorna el nmero de hijos que tiene el empleado de planta permanente"
	^ cantidadHijos! !

!EmpleadoPermanente methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 19:25'!
cantidadHijos: aCantidadHijos 
"Mtodo que asigna el nmero de hijos que tiene el empleado de planta permanente"
	cantidadHijos := aCantidadHijos ! !

Empleado subclass: #EmpleadoTemporario
	instanceVariableNames: 'cantidadHorasExtras finContrato'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!EmpleadoTemporario methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 19:51'!
calcularSueldoBruto: aRecibo
	"Mtodo para calcular el sueldo bruto de cada empleado de planta temporario"

	| sueldoBruto asignacionHorasExtras |
	asignacionHorasExtras := cantidadHorasExtras * 40.
	sueldoBruto := sueldoBasico + asignacionHorasExtras.
	aRecibo isNil
		ifFalse: [ 
			aRecibo
				addConcepto: 'Sueldo bsico' monto: sueldoBasico nivel: 0;
				addConcepto: 'Asignacin por horas extras' monto: asignacionHorasExtras nivel: 0 ].
	^ sueldoBruto! !

!EmpleadoTemporario methodsFor: 'as yet unclassified' stamp: 'DiegoValdeblanquez 6/14/2012 19:49'!
calcularTotalRetenciones: aRecibo
	"Este mtodo calcula el total de retenciones que tiene un empleado de planta permanente"

	| totalRetenciones obraSocial aportesjubilatorios sueldoBruto edad |
	sueldoBruto := self calcularSueldoBruto.
	edad := super calcularEdad.
	obraSocial := 0.1 * sueldoBruto.
	edad > 50
		ifTrue: [ obraSocial := obraSocial + 25 ].
	aportesjubilatorios := 0.1 * sueldoBruto + (5 * cantidadHorasExtras).
	totalRetenciones := obraSocial + aportesjubilatorios.
	aRecibo isNil
		ifFalse: [ 
			aRecibo
				addConcepto: 'Total de retenciones' monto: totalRetenciones negated nivel: 0;
				addConcepto: 'Obra social' monto: obraSocial negated nivel: 1;
				addConcepto: 'Aportes jubilatorios' monto: aportesjubilatorios negated nivel: 1 ].
	^ totalRetenciones! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:39'!
cantidadHorasExtra: aCantidadHorasExtra 
	cantidadHorasExtras := aCantidadHorasExtra ! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:44'!
cantidadHorasExtras
	^ cantidadHorasExtras! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:45'!
finContrato
	^ finContrato! !

!EmpleadoTemporario methodsFor: 'accessing' stamp: 'Olga LucÃ­a Sarmiento 6/13/2012 22:39'!
finContrato: aFinContrato 
	finContrato := aFinContrato ! !

Object subclass: #Empresa
	instanceVariableNames: 'nombre CUIT empleados recibos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:38'!
CUIT
	^ CUIT! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:14'!
CUIT: aCUIT
	CUIT = aCUIT! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 20:27'!
addEmpleado: aEmpleado
	"Agrega un empleado al arreglo de empleados"

	aEmpleado isNil
		ifFalse: [ empleados add: aEmpleado ]! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:08'!
calcularTotalRetenciones
	"Calcula el total de retenciones de la coleccin de empleados de la empresa"

	| totalRetenciones |
	totalRetenciones := 0.
	empleados do: [ :empleado | totalRetenciones := totalRetenciones + empleado calcularTotalRetenciones ].
	^ totalRetenciones! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:08'!
calcularTotalSueldosBrutos
	"Calcula el total de sueldos brutos de la coleccin de empleados de la empresa"

	| totalSueldosBrutos |
	totalSueldosBrutos := 0.
	empleados do: [ :empleado | totalSueldosBrutos := totalSueldosBrutos + empleado calcularSueldoBruto ].
	^ totalSueldosBrutos! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 00:10'!
calcularTotalSueldosNetos
	"Calcula el total de sueldos netos de la coleccin de empleados de la empresa"

	| totalSueldosNetos |
	totalSueldosNetos := 0.
	empleados do: [ :empleado | totalSueldosNetos := totalSueldosNetos + empleado calcularSueldoNeto ].
	^ totalSueldosNetos! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:39'!
empleados
	^ empleados! !

!Empresa methodsFor: 'initialize-release' stamp: 'PauloPerez 6/14/2012 15:00'!
initialize
	empleados := OrderedCollection new.
	recibos := OrderedCollection new! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/12/2012 23:52'!
nombre 
	^nombre! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 02:16'!
nombre: aNombre
	nombre = aNombre! !

!Empresa methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:55'!
realizarLiquidacionSueldos
	"Recorre los empleados, les pide que generen su recibo y se guarda ese recibo"

	empleados do: [ :empleado | recibos add: empleado generarRecibo ]! !

!Empresa methodsFor: 'accessing' stamp: 'PauloPerez 6/13/2012 00:39'!
recibos
	^ recibos! !

Object subclass: #ReciboHaberes
	instanceVariableNames: 'nombreEmpleado direccion fechaEmision sueldoBruto sueldoNeto renglones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!ReciboHaberes methodsFor: 'accessing' stamp: 'PauloPerez 6/14/2012 19:42'!
addConcepto: aConcepto monto: aMonto nivel: aNivel
	"Agrega un nuevo renglon a la coleccion que tiene el recibo"

	| renglon |
	renglon := Renglon new.
	renglon
		concepto: aConcepto;
		monto: aMonto;
		nivel: aNivel.
	renglones add: renglon! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:21'!
direccion 
	"Mtodo que retorna la direccin del empleado escrita en el recibo"

	^direccion ! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:20'!
direccion: direccionEmpleado
	"Mtodo que asigna la direccin del empleado al recibo"

	direccion := direccionEmpleado.! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:32'!
fechaEmision 
	"Mtodo que retorna la fecha de emisin del recibo"

	^fechaEmision ! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:29'!
fechaEmision: fechaRecibo
	"Mtodo que asigna la fecha de emisin del recibo"

	fechaEmision := fechaRecibo.! !

!ReciboHaberes methodsFor: 'initialize-release' stamp: 'PauloPerez 6/14/2012 14:26'!
initialize
	renglones := OrderedCollection new.! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:18'!
nombre
	"Mtodo que retorna el nombre del empleado"

	^nombreEmpleado! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:11'!
nombre: nombreEmp
	"Mtodo que asigna el nombre del empleado al recibo"
	
	nombreEmpleado := nombreEmp.
	! !

!ReciboHaberes methodsFor: 'printing' stamp: 'PauloPerez 6/14/2012 19:55'!
printOn: aStream
	aStream
		nextPutAll: 'Empleado: ';
		print: nombreEmpleado;
		space;
		space;
		nextPutAll: 'Direccion: ';
		print: direccion;
		space;
		space;
		nextPutAll: 'Fecha Emisin: ';
		print: fechaEmision;
		space;
		space;
		nextPutAll: 'Sueldo Bruto: ';
		print: sueldoBruto;
		space;
		space;
		nextPutAll: 'Sueldo Neto: ';
		print: sueldoNeto;
		cr;
		nextPutAll: 'Desgloce de Conceptos';
		cr.
	renglones do: [ :renglon | renglon printOn: aStream ].
	aStream cr! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:37'!
sueldoBruto 
	"Mtodo que retorna el valor del sueldo bruto del empleado"

	^sueldoBruto ! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:34'!
sueldoBruto: salarioBruto
	"Mtodo que asigna el sueldo bruto del empleado al recibo"

	sueldoBruto := salarioBruto.
	! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:41'!
sueldoNeto 
	"Mtodo que retorna el sueldo neto del empleado"

	^sueldoNeto ! !

!ReciboHaberes methodsFor: 'accessing' stamp: 'DiegoValdeblanquez 6/13/2012 20:39'!
sueldoNeto: salarioNeto
	"Mtodo que asigna el sueldo neto del empleado al recibo"

	sueldoNeto := salarioNeto. ! !

Object subclass: #Renglon
	instanceVariableNames: 'concepto monto nivel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Practica2-Ejercicio1'!

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:40'!
concepto
	^ concepto! !

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:43'!
concepto: aConcepto
	concepto := aConcepto! !

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:43'!
monto
	^ monto! !

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 14:44'!
monto: aMonto
	monto := aMonto! !

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 19:42'!
nivel 
	^ nivel! !

!Renglon methodsFor: 'as yet unclassified' stamp: 'PauloPerez 6/14/2012 19:42'!
nivel: aNivel
	nivel := aNivel! !

!Renglon methodsFor: 'printing' stamp: 'PauloPerez 6/14/2012 20:01'!
printOn: aStream
	[ nivel > 0 ]
		whileTrue: [ 
			aStream
				tab.
			nivel := nivel - 1 ].
	aStream
		nextPutAll: 'Concepto: ';
		print: concepto;
		space;
		space;
		nextPutAll: 'Monto: ';
		print: monto;
		cr! !
